'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _tslib = require('./_tslib-f635d183.js');
var fse = require('fs-extra');
var echo = require('./echo.js');
var getBasename = require('./getBasename.js');
var getDirname = require('./getDirname.js');
var getExtname = require('./getExtname.js');
var getFilename = require('./getFilename.js');
var glob = require('./glob.js');
var isAsyncFunction = require('./isAsyncFunction.js');
var normalizePath = require('./normalizePath.js');
var wrapList = require('./wrapList.js');
var run = require('./run.js');
require('kleur');
require('./home.js');
require('os');
require('./root.js');
require('./toString.js');
require('./getType.js');
require('./getName.js');
require('path');
require('fast-glob');
require('./toArray.js');
require('./isFunction.js');
require('./trimEnd-6fe615e8.js');

var execute = function (fn, input) {
    if (isAsyncFunction.default(fn))
        return fn(input);
    return fn(input);
};
var main = function (source, target, name) { return _tslib.__awaiter(void 0, void 0, void 0, function () {
    var listSource, _loop_1, _i, listSource_1, src;
    return _tslib.__generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, glob.default(source)];
            case 1:
                listSource = _a.sent();
                _loop_1 = function (src) {
                    var dirname, filename;
                    return _tslib.__generator(this, function (_b) {
                        switch (_b.label) {
                            case 0: return [4, run.default(function () {
                                    var dname = getDirname.default(src);
                                    if (!target)
                                        return dname;
                                    if (typeof target === 'function')
                                        return execute(target, dname);
                                    return target;
                                })];
                            case 1:
                                dirname = _b.sent();
                                return [4, run.default(function () {
                                        var fname = getFilename.default(src);
                                        if (!name)
                                            return dirname === getDirname.default(src)
                                                ? "".concat(getBasename.default(src), ".copy").concat(getExtname.default(src))
                                                : fname;
                                        if (typeof name === 'function')
                                            return execute(name, fname);
                                        return name;
                                    })];
                            case 2:
                                filename = _b.sent();
                                return [4, fse.copy(src, normalizePath.default("".concat(dirname, "/").concat(filename)))];
                            case 3:
                                _b.sent();
                                return [2];
                        }
                    });
                };
                _i = 0, listSource_1 = listSource;
                _a.label = 2;
            case 2:
                if (!(_i < listSource_1.length)) return [3, 5];
                src = listSource_1[_i];
                return [5, _loop_1(src)];
            case 3:
                _a.sent();
                _a.label = 4;
            case 4:
                _i++;
                return [3, 2];
            case 5:
                echo.default('file', [
                    "copied ".concat(wrapList.default(source)),
                    target && typeof target === 'string' ? " to '".concat(target, "'") : '',
                    name && typeof name === 'string' ? " as '".concat(name, "'") : '',
                ]
                    .filter(function (it) { return !!it; })
                    .join(''));
                return [2];
        }
    });
}); };

exports.default = main;
