'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var child = require('child_process');
var kleur = require('kleur');
var trimEnd = require('./trimEnd-6fe615e8.js');
var echo = require('./echo.js');
var os = require('./os.js');
require('./_tslib-f635d183.js');
require('./home.js');
require('os');
require('./root.js');
require('./toString.js');
require('./getType.js');

var separator = os.default() === 'windows' ? ' && ' : '; ';
var info = function (type, message) {
    if (!message)
        return;
    console.log(type === 'error' ? kleur.red(message) : kleur.gray(message));
};
var main = function (cmd, option) {
    if (option === void 0) { option = {}; }
    var stringCmd = cmd instanceof Array ? cmd.join(separator) : cmd;
    var _a = os.default() === 'windows'
        ? ['cmd.exe', ['/s', '/c', stringCmd]]
        : ['/bin/sh', ['-c', stringCmd]], cmder = _a[0], arg = _a[1];
    if (!option.silent)
        echo.default('exec', stringCmd);
    return new Promise(function (resolve) {
        var cacheAll = [];
        var cacheLast = '';
        var process = child.spawn(cmder, arg, {});
        process.stderr.on('data', function (data) {
            var message = parseMessage(data);
            cacheAll.push(message);
            cacheLast = message;
            if (!option.silent)
                info('error', message);
        });
        process.stdout.on('data', function (data) {
            var message = parseMessage(data);
            cacheAll.push(message);
            cacheLast = message;
            if (!option.silent)
                info('default', message);
        });
        process.on('close', function (code) { return resolve([code, cacheLast, cacheAll]); });
    });
};
var parseMessage = function (buffer) {
    return trimEnd.trimEnd(buffer.toString().trim(), '\n')
        .replace(/\r/g, '\n')
        .replace(/\n{2,}/g, '');
};

exports.default = main;
