'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var path = require('path');
var trimEnd = require('./trimEnd-6fe615e8.js');
var home = require('./home.js');
var root = require('./root.js');
require('os');

var main = function (source) {
    if (typeof source !== 'string')
        return '';
    if (!source)
        return '';
    var isIgnored = source.startsWith('!');
    var _source = isIgnored ? source.slice(1) : source;
    _source = _source.replace(/\.{2}/g, '__parent_directory__');
    if (_source.startsWith('.'))
        _source = _source.replace(/\./u, root.default());
    else if (_source.startsWith('~'))
        _source = _source.replace(/~/u, home.default());
    _source = _source.replace(/__parent_directory__/g, '..');
    if (_source.startsWith('..'))
        _source = "".concat(root.default(), "/").concat(_source);
    _source = path.normalize(_source).replace(/\\/g, '/');
    if (!path.isAbsolute(_source))
        _source = "".concat(root.default(), "/").concat(_source);
    if (isIgnored)
        _source = "!".concat(_source);
    return trimEnd.trimEnd(_source, '/');
};

exports.default = main;
